Index: trunk/kernel/kern/rpc.c
===================================================================
--- trunk/kernel/kern/rpc.c	(revision 690)
+++ trunk/kernel/kern/rpc.c	(revision 1)
@@ -41,676 +40,328 @@
 #include <vfs.h>
 #include <fatfs.h>
+#include <dev_icu.h>
 #include <rpc.h>
 
-
-/////////////////////////////////////////////////////////////////////////////////////////
-// Array of function pointers and array of printable strings.
-// These arrays must be kept consistent with enum in rpc.h file. 
+/////////////////////////////////////////////////////////////////////////////////////////
+//      array of function pointers  (must be consistent with enum in rpc.h) 
 /////////////////////////////////////////////////////////////////////////////////////////
 
 rpc_server_t * rpc_server[RPC_MAX_INDEX] =
 {
-    &rpc_undefined,                        // 0
-    &rpc_undefined,                        // 1
-    &rpc_undefined,                        // 2
-    &rpc_process_make_fork_server,         // 3
-    &rpc_user_dir_create_server,           // 4
-    &rpc_user_dir_destroy_server,          // 5
-    &rpc_thread_user_create_server,        // 6
-    &rpc_thread_kernel_create_server,      // 7
-    &rpc_undefined,                        // 8
-    &rpc_process_sigaction_server,         // 9
-
-    &rpc_undefined,                        // 10
-    &rpc_undefined,                        // 11
-    &rpc_undefined,                        // 12
-    &rpc_undefined,                        // 13
-    &rpc_undefined,                        // 14
-    &rpc_vmm_resize_vseg_server,           // 15
-    &rpc_vmm_remove_vseg_server,           // 16 
-    &rpc_vmm_create_vseg_server,           // 17
-    &rpc_vmm_set_cow_server,               // 18
-    &rpc_undefined,                        // 19
+    &rpc_pmem_get_pages_server,         // 0
+    &rpc_process_pid_alloc_server,      // 1
+    &rpc_process_exec_server,           // 2
+    &rpc_process_kill_server,           // 3
+    &rpc_thread_user_create_server,     // 4
+    &rpc_thread_kernel_create_server,   // 5
+    &rpc_icu_wti_alloc_server,          // 6                       
+    &rpc_device_alloc_server,           // 7
+    &rpc_undefined,                     // 8
+    &rpc_undefined,                     // 9
+
+    &rpc_vfs_inode_create_server,       // 10  
+    &rpc_vfs_inode_destroy_server,      // 11  
+    &rpc_vfs_dentry_create_server,      // 12  
+    &rpc_vfs_dentry_destroy_server,     // 13  
+    &rpc_undefined,                     // 14
+    &rpc_undefined,                     // 15
+    &rpc_undefined,                     // 16
+    &rpc_undefined,                     // 17
+    &rpc_undefined,                     // 18
+    &rpc_undefined,                     // 19
+
+    &rpc_vmm_get_ref_vseg_server,       // 20
+    &rpc_vmm_get_pte_server,            // 21
+    &rpc_semaphore_alloc_server,        // 22
+    &rpc_semaphore_free_server,         // 23
+    &rpc_mapper_move_server,            // 24
+    &rpc_undefined,                     // 25
+    &rpc_undefined,                     // 26
+    &rpc_undefined,                     // 27
+    &rpc_undefined,                     // 28
+    &rpc_undefined,                     // 29
+
+    &rpc_fatfs_get_cluster_server       // 30
 };
 
-char * rpc_str[RPC_MAX_INDEX] =
-{
-    "undefined_0",               // 0
-    "undefined_1",               // 1
-    "undefined_2",               // 2
-    "PROCESS_MAKE_FORK",         // 3
-    "USER_DIR_CREATE",           // 4
-    "USER_DIR_DESTROY",          // 5
-    "THREAD_USER_CREATE",        // 6
-    "THREAD_KERNEL_CREATE",      // 7
-    "FBF_DISPLAY",               // 8
-    "PROCESS_SIGACTION",         // 9
-
-    "undefined_10",              // 10
-    "undefined_11",              // 11
-    "undefined_12",              // 12
-    "undefined_13",              // 13
-    "undefined_14",              // 14
-    "VMM_RESIZE_VSEG",           // 15
-    "VMM_REMOVE_VSEG",           // 16
-    "VMM_CREATE_VSEG",           // 17
-    "VMM_SET_COW",               // 18
-    "undefined_19",              // 19
-};
-
-//////////////////////////////////////////////////////////////////////////////////
-void __attribute__((noinline)) rpc_undefined( xptr_t xp __attribute__ ((unused)) )
-{
-	assert( __FUNCTION__, false , "called in cluster %x", local_cxy );
-}
-
-/***************************************************************************************/
-/************ Generic function supporting RPCs : client side ***************************/
-/***************************************************************************************/
-
-///////////////////////////////////////
-void rpc_send( cxy_t        server_cxy, 
-               rpc_desc_t * rpc )
-{
-    lid_t              server_core_lid;
-    lid_t              client_core_lid;
-    volatile error_t   full;
-    thread_t         * this;
-
-    full            = 0;
-    this            = CURRENT_THREAD;
-    client_core_lid = this->core->lid;
-
-    // check calling thread can yield when is not the IDLE thread
-    // RPCs executed by the IDLE thread during kernel_init do not deschedule
-    if( this->type != THREAD_IDLE ) thread_assert_can_yield( this , __FUNCTION__ );
-
-    // select a server_core : use client core index if possible / core 0 otherwise
-    if( client_core_lid < hal_remote_l32( XPTR( server_cxy , &LOCAL_CLUSTER->cores_nr ) ) )
-    {
-        server_core_lid = client_core_lid;
-    }
-    else
-    {   
-        server_core_lid = 0;
-    }
-
-    // register client_thread and client_core in RPC descriptor
-    rpc->thread = this;
-    rpc->lid    = client_core_lid;
-
-    // build extended pointer on the RPC descriptor
-	xptr_t   desc_xp = XPTR( local_cxy , rpc );
-
-    // get local pointer on rpc_fifo in remote cluster,
-    remote_fifo_t * rpc_fifo    = &LOCAL_CLUSTER->rpc_fifo[server_core_lid];
-    xptr_t          rpc_fifo_xp = XPTR( server_cxy , rpc_fifo );
-
-	// post RPC in remote fifo / deschedule without blocking if fifo full
-    do
-    { 
-        full = remote_fifo_put_item( rpc_fifo_xp , (uint64_t )desc_xp );
-
-	    if ( full ) 
-        {
-            printk("\n[WARNING] %s : cluster %x cannot post RPC to cluster %x\n",
-            __FUNCTION__ , local_cxy , server_cxy );
-
-            // deschedule without blocking 
-            sched_yield("RPC fifo full");
-        }
-    }
-    while( full );
- 
-#if DEBUG_RPC_CLIENT_GENERIC
-uint32_t cycle = (uint32_t)hal_get_cycles();
-uint32_t items = remote_fifo_items( rpc_fifo_xp );
-if( DEBUG_RPC_CLIENT_GENERIC < cycle ) 
-printk("\n[%s] thread[%x,%x] / rpc %s / server[%x,%d] / items %d / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, rpc_str[rpc->index], 
-server_cxy, server_core_lid, items, cycle );
-#endif
-	
-   // send IPI to the selected server core
-   dev_pic_send_ipi( server_cxy , server_core_lid );
-
-    // wait RPC completion before returning if blocking RPC :
-    // - deschedule without blocking if thread idle (in kernel init)
-    // - block and deschedule policy for any other thread
-    if ( rpc->blocking )
-    {
-        if( this->type == THREAD_IDLE )  // deschedule without blocking policy
-        {
-  
-#if DEBUG_RPC_CLIENT_GENERIC
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_RPC_CLIENT_GENERIC < cycle ) 
-printk("\n[%s] thread[%x,%x] enter waiting loop for rpc %s / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, rpc_str[rpc->index], cycle );
-#endif
-             while( 1 )
-             {
-                 // check responses counter
-                 if( hal_remote_l32( XPTR( local_cxy , rpc->rsp ) ) == 0 ) break;
-                   
-                 // deschedule
-                 sched_yield("busy_waiting RPC completion");
-             }
-
-#if DEBUG_RPC_CLIENT_GENERIC
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_RPC_CLIENT_GENERIC < cycle ) 
-printk("\n[%s] thread[%x,%x] received response for rpc %s / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, rpc_str[rpc->index], cycle );
-#endif
- 
-        }
-        else                            // block and deschedule policy
-        {
-
-#if DEBUG_RPC_CLIENT_GENERIC
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_RPC_CLIENT_GENERIC < cycle ) 
-printk("\n[%s] thread[%x,%x] blocks & deschedules for rpc %s / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, rpc_str[rpc->index], cycle );
-#endif
-
-        // block client thread
-        thread_block( XPTR( local_cxy , this ) , THREAD_BLOCKED_RPC );
-
-        // deschedule
-        sched_yield("blocked on RPC");
-
-#if DEBUG_RPC_CLIENT_GENERIC
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_RPC_CLIENT_GENERIC < cycle ) 
-printk("\n[%s] thread[%x,%x] resumes after rpc %s / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, rpc_str[rpc->index], cycle );
-#endif
-        }
-
-// response must be available for a blocking RPC
-assert( __FUNCTION__, (*rpc->rsp == 0) , "illegal response for RPC %s\n", rpc_str[rpc->index] );
-
-    }
-    else       // non blocking RPC
-    {
-
-#if DEBUG_RPC_CLIENT_GENERIC
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_RPC_CLIENT_GENERIC < cycle ) 
-printk("\n[%s] thread[%x,%x] returns for non blocking rpc %s / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, rpc_str[rpc->index], cycle );
-#endif
-
-    }
-}  // end rpc_send()
-
-
-/***************************************************************************************/
-/************ Generic functions supporting RPCs : server side **************************/
-/***************************************************************************************/
-
-////////////////////////////
-void rpc_server_func( void )
-{
-    error_t         empty;              // local RPC fifo state
-    xptr_t          desc_xp;            // extended pointer on RPC request
-    cxy_t           desc_cxy;           // RPC request cluster (client) 
-    rpc_desc_t    * desc_ptr;           // RPC request local pointer 
-    uint32_t        index;              // RPC request index 
-    thread_t      * client_ptr;         // local pointer on client thread
-    xptr_t          client_xp;          // extended pointer on client thread
-    lid_t           client_lid;         // local index of client core
-	thread_t      * server_ptr;         // local pointer on server thread
-    xptr_t          server_xp;          // extended pointer on server thread
-    lid_t           server_lid;         // local index of server core
-	remote_fifo_t * rpc_fifo;           // local pointer on RPC fifo
-    uint32_t      * rsp_ptr;            // local pointer on responses counter
-    xptr_t          rsp_xp;             // extended pointer on responses counter
-    uint32_t        responses;          // number of expected responses
-
-    // makes RPC thread not preemptable
-	hal_disable_irq( NULL );
-  
-	server_ptr      = CURRENT_THREAD;
-    server_xp       = XPTR( local_cxy , server_ptr );
-    server_lid      = server_ptr->core->lid;
-	rpc_fifo        = &LOCAL_CLUSTER->rpc_fifo[server_lid];
-
-    // "infinite" RPC thread loop
-	while(1)
-	{
-        // try to take RPC_FIFO ownership
-        if( hal_atomic_test_set( &rpc_fifo->owner , server_ptr->trdid ) ) 
-        {
-
-#if DEBUG_RPC_SERVER_GENERIC 
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_RPC_SERVER_GENERIC < cycle ) 
-printk("\n[%s] RPC thread[%x,%x] on core[%d] takes RPC_FIFO ownership / cycle %d\n",
-__FUNCTION__, server_ptr->process->pid, server_ptr->trdid, server_lid, cycle );
-#endif
-	        // try to consume one RPC request  
-  	        empty = remote_fifo_get_item( rpc_fifo , (uint64_t *)&desc_xp );
-
-            // release RPC_FIFO ownership
-            rpc_fifo->owner = 0;
-
-            // handle RPC request if success
-	        if ( empty == 0 )   
-            {
-                // get client cluster and pointer on RPC descriptor
-                desc_cxy = GET_CXY( desc_xp );
-                desc_ptr = GET_PTR( desc_xp );
-
-                // get relevant infos from RPC descriptor
-	            index      = hal_remote_l32( XPTR( desc_cxy , &desc_ptr->index ) );
-                client_ptr = hal_remote_lpt( XPTR( desc_cxy , &desc_ptr->thread ) );
-                rsp_ptr    = hal_remote_lpt( XPTR( desc_cxy , &desc_ptr->rsp ) );
-                client_lid = hal_remote_l32( XPTR( desc_cxy , &desc_ptr->lid ) );
-
-                rsp_xp     = XPTR( desc_cxy , rsp_ptr );
-                client_xp  = XPTR( desc_cxy , client_ptr );
-
-#if DEBUG_RPC_SERVER_GENERIC
-cycle = (uint32_t)hal_get_cycles();
-uint32_t items = remote_fifo_items( XPTR( local_cxy , rpc_fifo ) );
-if( DEBUG_RPC_SERVER_GENERIC < cycle ) 
-printk("\n[%s] RPC thread[%x,%x] got rpc %s / client_cxy %x / items %d / cycle %d\n",
-__FUNCTION__, server_ptr->process->pid, server_ptr->trdid, rpc_str[index], desc_cxy, items, cycle );
-#endif
-                // register client thread in RPC thread descriptor
-                server_ptr->rpc_client_xp = client_xp;
- 
-                // call the relevant server function
-                rpc_server[index]( desc_xp );
-
-                // update responses counter
-                responses = hal_remote_atomic_add( rsp_xp , -1 );
-
-#if DEBUG_RPC_SERVER_GENERIC
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_RPC_SERVER_GENERIC < cycle ) 
-printk("\n[%s] RPC thread[%x,%x] completes rpc %s / responses %d / cycle %d\n",
-__FUNCTION__, server_ptr->process->pid, server_ptr->trdid, rpc_str[index], responses, cycle );
-#endif
-                // decrement expected responses counter 
-                // unblock client thread if last response
-                if( responses == 1 ) 
-                {
-                    // unblock client thread
-                    thread_unblock( client_xp , THREAD_BLOCKED_RPC );
-
-                    hal_fence();
-
-#if DEBUG_RPC_SERVER_GENERIC
-cycle = (uint32_t)hal_get_cycles();
-trdid_t     client_trdid = hal_remote_l32( XPTR( desc_cxy , &client_ptr->trdid ) );
-process_t * process      = hal_remote_lpt( XPTR( desc_cxy , &client_ptr->process ) );
-pid_t       client_pid   = hal_remote_l32( XPTR( desc_cxy , &process->pid ) );
-if( DEBUG_RPC_SERVER_GENERIC < cycle ) 
-printk("\n[%s] RPC thread[%x,%x] unblocked client thread[%x,%x] / cycle %d\n",
-__FUNCTION__, server_ptr->process->pid, server_ptr->trdid,
-client_pid, client_trdid, cycle );
-#endif
-                    // send IPI to client core
-                    dev_pic_send_ipi( desc_cxy , client_lid );
-                }
-            }  // end RPC handling if fifo non empty
-        }  // end if RPC_fIFO ownership successfully taken and released
-
-        // sucide if too many RPC threads 
-        if( LOCAL_CLUSTER->rpc_threads[server_lid] >= CONFIG_RPC_THREADS_MAX )
-	    {
-
-#if DEBUG_RPC_SERVER_GENERIC
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_RPC_SERVER_GENERIC < cycle ) 
-printk("\n[%s] RPC thread[%x,%x] suicides / cycle %d\n",
-__FUNCTION__, server_ptr->process->pid, server_ptr->trdid, cycle );
-#endif
-            // update RPC threads counter
-	        hal_atomic_add( &LOCAL_CLUSTER->rpc_threads[server_lid] , -1 );
-
-            // RPC thread blocks on GLOBAL
-	        thread_block( server_xp , THREAD_BLOCKED_GLOBAL );
-
-            // RPC thread set the REQ_DELETE flag to suicide
-            hal_remote_atomic_or( server_xp , THREAD_FLAG_REQ_DELETE );
-	    }
-        // block and deschedule otherwise
-        else
-        {
-
-#if DEBUG_RPC_SERVER_GENERIC
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_RPC_SERVER_GENERIC < cycle ) 
-printk("\n[%s] RPC thread[%x,%x] blocks & deschedules / cycle %d\n",
-__FUNCTION__, server_ptr->process->pid, server_ptr->trdid, cycle );
-#endif
-            // RPC thread blocks on IDLE 
-            thread_block( server_xp , THREAD_BLOCKED_IDLE );
-
-            // RPC thread deschedules
-            sched_yield("RPC_FIFO empty");
-        }
-	} // end infinite loop
-
-} // end rpc_server_func()
-
-
-/***************************************************************************************/
-/************ Marshaling functions ordered by increasing index *************************/
-/***************************************************************************************/
-
-
-/////////////////////////////////////////////////////////////////////////////////////////
-// [0]           undefined                                               
-/////////////////////////////////////////////////////////////////////////////////////////
-
-/////////////////////////////////////////////////////////////////////////////////////////
-// [1]           undefined                                               
-/////////////////////////////////////////////////////////////////////////////////////////
-
-/////////////////////////////////////////////////////////////////////////////////////////
-// [2]           undefined                                               
-/////////////////////////////////////////////////////////////////////////////////////////
-
-
-/////////////////////////////////////////////////////////////////////////////////////////
-// [3]           Marshaling function attached to RPC_MAKE_FORK           
+//////////////////////////////////////////////
+void __attribute__((noinline)) rpc_undefined()
+{
+    printk("\n[PANIC] ‰s called in cluster %x\n", __FUNCTION__ , local_cxy );
+    hal_core_sleep();
+}
+
+/////////////////////////////////////////////////////////////////////////////////////////
+//               Marshaling functions attached to RPC_PMEM_GET_PAGES 
+/////////////////////////////////////////////////////////////////////////////////////////
+
+///////////////////////////////////////////////
+void rpc_pmem_get_pages_client( cxy_t      cxy,
+                                uint32_t   order,      // in 
+                                error_t  * error,      // out 
+                                uint32_t * ppn )       // out 
+{
+    // any RPC must be remote
+    if( cxy == local_cxy ) 
+    {
+        printk("PANIC in %s : target is not remote\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // initialise RPC descriptor header 
+    rpc_desc_t  rpc;
+    rpc.index    = RPC_PMEM_GET_PAGES;
+    rpc.response = 1;
+
+    // set input arguments in RPC descriptor 
+    rpc.args[0] = (uint64_t)order;
+
+    // register RPC request in remote RPC fifo (blocking function)
+    rpc_send_sync( cxy , &rpc );
+
+    // get output arguments RPC descriptor
+    *error  = (error_t)rpc.args[0];     
+    *ppn    = (uint32_t)rpc.args[1];
+}
+
+///////////////////////////////////////////
+void rpc_pmem_get_pages_server( xptr_t xp )
+{
+    uint32_t order;  // input
+    error_t  error;  // output
+    uint32_t ppn;    // output
+
+    // get client cluster identifier and pointer on RPC descriptor
+    cxy_t        cxy  = (cxy_t)GET_CXY( xp );
+    rpc_desc_t * desc = (rpc_desc_t *)GET_PTR( xp );
+
+    // get input arguments from client RPC descriptor
+    order = hal_remote_lw( XPTR( cxy , &desc->args[0] ) );
+    
+    // call local pmem allocator
+    page_t * page = ppm_alloc_pages( order ); 
+    error = ( page == NULL ) ? ENOMEM : 0;
+    ppn   = ppm_page2ppn( page );
+
+    // set output arguments into client RPC descriptor
+    hal_remote_sw( XPTR( cxy , &desc->args[0] ) , error );
+    hal_remote_sw( XPTR( cxy , &desc->args[1] ) , ppn );
+}
+
+/////////////////////////////////////////////////////////////////////////////////////////
+//               Marshaling functions attached to RPC_PROCESS_PID_ALLOC
+/////////////////////////////////////////////////////////////////////////////////////////
+
+//////////////////////////////////////////////////
+void rpc_process_pid_alloc_client( cxy_t       cxy, 
+                                   process_t * process,  // in
+                                   error_t   * error,    // out
+                                   pid_t     * pid )     // out
+{
+    // RPC must be remote
+    if( cxy == local_cxy ) 
+    {
+        printk("PANIC in %s : target is not remote\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // initialise RPC descriptor header 
+    rpc_desc_t  rpc;
+    rpc.index    = RPC_PROCESS_PID_ALLOC;
+    rpc.response = 1;
+
+    // set input arguments in RPC descriptor 
+    rpc.args[0] = (uint64_t)(intptr_t)process;
+
+    // register RPC request in remote RPC fifo (blocking function)
+    rpc_send_sync( cxy , &rpc );
+
+    // get output arguments RPC descriptor
+    *pid    = (pid_t)rpc.args[1];
+    *error  = (error_t)rpc.args[2];     
+}
+
+//////////////////////////////////////////////
+void rpc_process_pid_alloc_server( xptr_t xp )
+{
+    process_t * process;   // input  : client process descriptor
+    error_t     error;     // output : error status
+    pid_t       pid;       // output : process identifier
+
+    // get client cluster identifier and pointer on RPC descriptor
+    cxy_t        client_cxy  = (cxy_t)GET_CXY( xp );
+    rpc_desc_t * desc        = (rpc_desc_t *)GET_PTR( xp );
+
+    // get input argument from client RPC descriptor
+    process = (process_t*)(intptr_t)hal_remote_lwd( XPTR( client_cxy , &desc->args[0] ) );
+    
+    // call local pid allocator 
+    xptr_t xp_process = XPTR( client_cxy , process );
+    error = cluster_pid_alloc( xp_process , &pid ); 
+
+    // set output arguments into client RPC descriptor
+    hal_remote_sw( XPTR( client_cxy , &desc->args[0] ) , (uint64_t)error );
+    hal_remote_sw( XPTR( client_cxy , &desc->args[1] ) , (uint64_t)pid );
+}
+
+
+/////////////////////////////////////////////////////////////////////////////////////////
+//               Marshaling functions attached to RPC_PROCESS_EXEC 
+/////////////////////////////////////////////////////////////////////////////////////////
+
+////////////////////////////////////////////////
+void rpc_process_exec_client( cxy_t         cxy,
+                              exec_info_t * info,     // in
+                              error_t     * error )   // out
+{
+    // RPC must be remote
+    if( cxy == local_cxy ) 
+    {
+        printk("PANIC in %s : target is not remote\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // initialise RPC descriptor header 
+    rpc_desc_t  rpc;
+    rpc.index    = RPC_PROCESS_EXEC;
+    rpc.response = 1;
+
+    // set input arguments in RPC descriptor  
+    rpc.args[0] = (uint64_t)(intptr_t)info;
+
+    // register RPC request in remote RPC fifo (blocking function)
+    rpc_send_sync( cxy , &rpc );
+
+    // get output arguments from RPC descriptor
+    *error  = (error_t)rpc.args[1];     
+}
+
+/////////////////////////////////////////
+void rpc_process_exec_server( xptr_t xp )
+{
+    exec_info_t * ptr;       // local pointer on remote exec_info structure
+    exec_info_t   info;      // local copy of exec_info structure
+    error_t       error;     // local error error status
+
+    // get client cluster identifier and pointer on RPC descriptor
+    cxy_t        client_cxy  = (cxy_t)GET_CXY( xp );
+    rpc_desc_t * desc        = (rpc_desc_t *)GET_PTR( xp );
+
+    // get pointer on exec_info structure in client cluster from RPC descriptor
+    ptr = (exec_info_t*)(intptr_t)hal_remote_lwd( XPTR( client_cxy , &desc->args[0] ) );
+
+    // copy exec_info structure from client buffer to server buffer
+    hal_remote_memcpy( XPTR( client_cxy , ptr ),
+                       XPTR( local_cxy , &info ),
+                       sizeof(exec_info_t) );
+
+    // call local kernel function
+    error = process_make_exec( &info ); 
+
+    // set output argument into client RPC descriptor
+    hal_remote_swd( XPTR( client_cxy , &desc->args[1] ) , (uint64_t)error );
+}
+
+
+/////////////////////////////////////////////////////////////////////////////////////////
+//               Marshaling functions attached to RPC_PROCESS_KILL 
 /////////////////////////////////////////////////////////////////////////////////////////
 
 ///////////////////////////////////////////////////
-void rpc_process_make_fork_client( cxy_t       cxy,
-                                   xptr_t      ref_process_xp,      // in
-                                   xptr_t      parent_thread_xp,    // in
-                                   pid_t     * child_pid,           // out
-                                   thread_t ** child_thread_ptr,    // out     
-                                   error_t   * error )              // out
-{
-#if DEBUG_RPC_PROCESS_MAKE_FORK
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_PROCESS_MAKE_FORK )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-
-    uint32_t responses = 1;
-
-    // initialise RPC descriptor header 
-    rpc_desc_t  rpc;
-    rpc.index    = RPC_PROCESS_MAKE_FORK;
-    rpc.blocking = true;
-    rpc.rsp      = &responses;
-
-    // set input arguments in RPC descriptor  
-    rpc.args[0] = (uint64_t)ref_process_xp;
-    rpc.args[1] = (uint64_t)parent_thread_xp;
-
-    // register RPC request in remote RPC fifo
-    rpc_send( cxy , &rpc );
-
-    // get output arguments from RPC descriptor
-    *child_pid         = (pid_t)rpc.args[2];
-    *child_thread_ptr  = (thread_t *)(intptr_t)rpc.args[3];
-    *error             = (error_t)rpc.args[4];     
-
-#if DEBUG_RPC_PROCESS_MAKE_FORK
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_PROCESS_MAKE_FORK )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-}
-
-//////////////////////////////////////////////
-void rpc_process_make_fork_server( xptr_t xp )
-{
-#if DEBUG_RPC_PROCESS_MAKE_FORK
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_PROCESS_MAKE_FORK )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-
-    xptr_t     ref_process_xp;     // extended pointer on reference parent process
-    xptr_t     parent_thread_xp;   // extended pointer on parent thread
-    pid_t      child_pid;          // child process identifier
-    thread_t * child_thread_ptr;   // local copy of exec_info structure
-    error_t    error;              // local error status
-
-    // get client cluster identifier and pointer on RPC descriptor
-    cxy_t        client_cxy  = GET_CXY( xp );
-    rpc_desc_t * desc        = GET_PTR( xp );
-
-    // get input arguments from cient RPC descriptor
-    ref_process_xp   = (xptr_t)hal_remote_l64( XPTR( client_cxy , &desc->args[0] ) );
-    parent_thread_xp = (xptr_t)hal_remote_l64( XPTR( client_cxy , &desc->args[1] ) );
-
-    // call local kernel function
-    error = process_make_fork( ref_process_xp,
-                               parent_thread_xp,
-                               &child_pid,
-                               &child_thread_ptr ); 
-
-    // set output argument into client RPC descriptor
-    hal_remote_s64( XPTR( client_cxy , &desc->args[2] ) , (uint64_t)child_pid );
-    hal_remote_s64( XPTR( client_cxy , &desc->args[3] ) , (uint64_t)(intptr_t)child_thread_ptr );
-    hal_remote_s64( XPTR( client_cxy , &desc->args[4] ) , (uint64_t)error );
-
-#if DEBUG_RPC_PROCESS_MAKE_FORK
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_PROCESS_MAKE_FORK )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-}
-
-/////////////////////////////////////////////////////////////////////////////////////////
-// [4]      Marshaling functions attached to RPC_USER_DIR_CREATE  
-/////////////////////////////////////////////////////////////////////////////////////////
-
-////////////////////////////////////////////////////
-void rpc_user_dir_create_client( cxy_t          cxy,
-                                 vfs_inode_t *  inode,
-                                 xptr_t         ref_xp,
-                                 user_dir_t  ** dir )
-{
-#if DEBUG_RPC_USER_DIR_CREATE
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_USER_DIR_CREATE)
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-
-    uint32_t responses = 1;
-
-    // initialise RPC descriptor header 
-    rpc_desc_t  rpc;
-    rpc.index    = RPC_USER_DIR_CREATE;
-    rpc.blocking = true;
-    rpc.rsp      = &responses;
-
-    // set input arguments in RPC descriptor 
-    rpc.args[0] = (uint64_t)(intptr_t)inode;
-    rpc.args[1] = (uint64_t)ref_xp;
-
-    // register RPC request in remote RPC fifo
-    rpc_send( cxy , &rpc );
-
-    // get output argument from RPC descriptor
-    *dir = (user_dir_t *)(intptr_t)rpc.args[2];
-
-#if DEBUG_RPC_USER_DIR_CREATE
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_USER_DIR_CREATE)
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-}
-
-////////////////////////////////////////////
-void rpc_user_dir_create_server( xptr_t xp )
-{
-#if DEBUG_RPC_USER_DIR_CREATE
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_USER_DIR_CREATE)
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-
-    vfs_inode_t * inode;          // pointer on inode in server cluster
-    xptr_t        ref_xp;         // extended pointer on reference user process
-    user_dir_t  * dir;            // pointer on user_dir structure in server cluster 
-
-    // get client cluster identifier and pointer on RPC descriptor
-    cxy_t        client_cxy  = GET_CXY( xp );
-    rpc_desc_t * desc        = GET_PTR( xp );
-
-    // get input argument from RPC descriptor
-    inode  = (vfs_inode_t *)(intptr_t)hal_remote_l64(XPTR(client_cxy , &desc->args[0]));
-    ref_xp = (xptr_t)                 hal_remote_l64(XPTR(client_cxy , &desc->args[1]));
-
-    // call kernel function
-    dir = user_dir_create( inode , ref_xp );
-
-    // set output argument into RPC descriptor
-    hal_remote_s64( XPTR( client_cxy , &desc->args[2] ) , (intptr_t)dir );
-
-#if DEBUG_RPC_USER_DIR_CREATE
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_USER_DIR_CREATE)
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-}
-
-/////////////////////////////////////////////////////////////////////////////////////////
-// [5]      Marshaling functions attached to RPC_USER_DIR_DESTROY 
-/////////////////////////////////////////////////////////////////////////////////////////
-
-////////////////////////////////////////////////////
-void rpc_user_dir_destroy_client( cxy_t         cxy,
-                                  user_dir_t  * dir,
-                                  xptr_t        ref_xp )
-{
-#if DEBUG_RPC_USER_DIR_DESTROY
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_USER_DIR_DESTROY)
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-
-    uint32_t responses = 1;
-
-    // initialise RPC descriptor header 
-    rpc_desc_t  rpc;
-    rpc.index    = RPC_USER_DIR_DESTROY;
-    rpc.blocking = true;
-    rpc.rsp      = &responses;
-
-    // set input arguments in RPC descriptor 
-    rpc.args[0] = (uint64_t)(intptr_t)dir;
-    rpc.args[1] = (uint64_t)ref_xp;
-
-    // register RPC request in remote RPC fifo
-    rpc_send( cxy , &rpc );
-
-#if DEBUG_RPC_USER_DIR_DESTROY
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_USER_DIR_DESTROY)
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-}
-
-/////////////////////////////////////////////
-void rpc_user_dir_destroy_server( xptr_t xp )
-{
-#if DEBUG_RPC_USER_DIR_DESTROY
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_USER_DIR_DESTROY)
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-
-    user_dir_t * dir;            // pointer on user_dir structure in server cluster 
-    xptr_t       ref_xp;         // extended pointer on reference process
-
-    // get client cluster identifier and pointer on RPC descriptor
-    cxy_t        client_cxy  = GET_CXY( xp );
-    rpc_desc_t * desc        = GET_PTR( xp );
-
-    // get input argument from RPC descriptor
-    dir    = (user_dir_t *)(intptr_t)hal_remote_l64(XPTR(client_cxy , &desc->args[0]));
-    ref_xp = (xptr_t)                hal_remote_l64(XPTR(client_cxy , &desc->args[1]));
-
-    // call kernel function
-    user_dir_destroy( dir , ref_xp );
-
-#if DEBUG_RPC_USER_DIR_DESTROY
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_USER_DIR_DESTROY)
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-}
-
-/////////////////////////////////////////////////////////////////////////////////////////
-// [6]      Marshaling functions attached to RPC_THREAD_USER_CREATE   
+void rpc_process_kill_client( process_t * process ) 
+{
+    // only reference cluster can send this RPC
+    if( !process->is_ref )
+    {
+        printk("PANIC in %s : caller is not the reference process\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // get local process index in reference cluster
+    lpid_t lpid = LPID_FROM_PID( process->pid );
+
+    // get local process manager pointer
+    pmgr_t * pmgr = &LOCAL_CLUSTER->pmgr;
+
+    // get number of copies
+    uint32_t copies = pmgr->copies_nr[lpid];
+
+    // initialise RPC descriptor 
+    rpc_desc_t  rpc;
+    rpc.index    = RPC_PROCESS_KILL;
+    rpc.response = copies;
+    rpc.args[0]  = (uint64_t)process->pid;
+
+    // loop on list of copies to send RPC
+    xptr_t  iter;
+    XLIST_FOREACH( XPTR( local_cxy , &pmgr->copies_root[lpid] ) , iter )
+    {
+        // get cluster_identifier for current copy
+        cxy_t  target_cxy = GET_CXY( iter );
+
+        // register RPC request in remote RPC fifo ... but the reference
+        if( target_cxy != local_cxy ) rpc_send_sync( target_cxy , &rpc );
+    }
+}  
+
+/////////////////////////////////////////
+void rpc_process_kill_server( xptr_t xp )
+{
+    pid_t       pid;
+    process_t * process;  
+
+    // get client cluster identifier and pointer on RPC descriptor
+    cxy_t        client_cxy  = (cxy_t)GET_CXY( xp );
+    rpc_desc_t * desc        = (rpc_desc_t *)GET_PTR( xp );
+
+    // get pid argument from RPC descriptor
+    pid = (pid_t)hal_remote_lwd( XPTR( client_cxy , &desc->args[0] ) );
+
+    // get process pointer to call local kernel function
+    process = cluster_get_local_process_from_pid( pid );
+
+    if( process == NULL )  // process not found => do nothing
+    {
+        printk("\n[WARNING] in %s : process %x not found in cluster %x\n",
+               __FUNCTION__ , pid , local_cxy );
+    }
+    else                   // destroy process 
+    {
+        process_kill( process ); 
+    }
+} 
+
+
+/////////////////////////////////////////////////////////////////////////////////////////
+//               Marshaling functions attached to RPC_THREAD_USER_CREATE               
 /////////////////////////////////////////////////////////////////////////////////////////
 
 /////////////////////////////////////////////////////////
 void rpc_thread_user_create_client( cxy_t            cxy,  
-                                    pid_t            pid,         // in
-                                    void           * start_func,  // in
-                                    void           * start_arg,   // in
                                     pthread_attr_t * attr,        // in
                                     xptr_t         * thread_xp,   // out 
                                     error_t        * error )      // out 
 {
-#if DEBUG_RPC_THREAD_USER_CREATE
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_THREAD_USER_CREATE)
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-   
-    uint32_t responses = 1;
+    // RPC must be remote
+    if( cxy == local_cxy ) 
+    {
+        printk("\n[PANIC] in %s : target is not remote\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
 
     // initialise RPC descriptor header 
     rpc_desc_t  rpc;
     rpc.index    = RPC_THREAD_USER_CREATE;
-    rpc.blocking = true;
-    rpc.rsp      = &responses;
+    rpc.response = 1;
 
     // set input arguments in RPC descriptor 
-    rpc.args[0] = (uint64_t)pid;
-    rpc.args[1] = (uint64_t)(intptr_t)start_func;
-    rpc.args[2] = (uint64_t)(intptr_t)start_arg;
-    rpc.args[3] = (uint64_t)(intptr_t)attr;
-
-    // register RPC request in remote RPC fifo
-    rpc_send( cxy , &rpc );
+    rpc.args[0] = (uint64_t)(intptr_t)attr;
+
+    // register RPC request in remote RPC fifo 
+    rpc_send_sync( cxy , &rpc );
 
     // get output arguments from RPC descriptor
-    *thread_xp = (xptr_t)rpc.args[4];
-    *error     = (error_t)rpc.args[5];
-
-#if DEBUG_RPC_THREAD_USER_CREATE
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_THREAD_USER_CREATE)
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
+    *thread_xp = (xptr_t)rpc.args[1];
+    *error     = (error_t)rpc.args[2];
 }
 
